package com.s5gi.item.behaviors;

import com.s5gi.networking.LacessNetworking;
import com.s5gi.networking.payloads.S2C.HudRendererTimeUpdatePayload;
import net.fabricmc.fabric.api.itemgroup.v1.ItemGroupEvents;
import net.minecraft.entity.EntityType;
import net.minecraft.entity.LightningEntity;
import net.minecraft.entity.effect.StatusEffect;
import net.minecraft.entity.effect.StatusEffectInstance;
import net.minecraft.entity.effect.StatusEffects;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.Item;
import net.minecraft.item.ItemGroup;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.registry.RegistryKey;
import net.minecraft.registry.RegistryKeys;
import net.minecraft.util.ActionResult;
import net.minecraft.util.Hand;
import net.minecraft.util.Identifier;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import static com.s5gi.Lacess.MOD_ID;

public class Test_Dust extends Item {
    public Test_Dust(Settings settings) {
        super(settings);
    }

    @Override
    public ActionResult use(World world, PlayerEntity user, Hand hand) {
        //If player on server, pass event to server for handling. Else run on local world
        if (world.isClient) {
            return ActionResult.PASS;
        }


        if (!user.isInCreativeMode()) user.getStackInHand(hand).decrement(1);

        LacessNetworking.S2C.sendPayload(user.getServer().getPlayerManager().getPlayer(user.getUuid()), new HudRendererTimeUpdatePayload("1", System.currentTimeMillis()));

//        BlockPos frontOfPlayer = user.getBlockPos().offset(user.getHorizontalFacing(), 10);

        // Spawn the lightning bolt.
//        LightningEntity lightningBolt = new LightningEntity(EntityType.LIGHTNING_BOLT, world);
//        lightningBolt.setPosition(frontOfPlayer.toCenterPos());
//        world.spawnEntity(lightningBolt);
        user.addStatusEffect(new StatusEffectInstance(StatusEffects.SPEED, 40, 1));


        return ActionResult.SUCCESS;
    }

    public static Item register(String name, RegistryKey<ItemGroup> itemGroup) {
        Identifier id = Identifier.of(MOD_ID, name);
        RegistryKey<Item> key = RegistryKey.of(RegistryKeys.ITEM, id);
        Item.Settings settings = new Item.Settings().registryKey(key);
        Item item = Registry.register(Registries.ITEM, key, new Test_Dust(settings));
        ItemGroupEvents.modifyEntriesEvent(itemGroup)
                .register((itemGroupa) -> itemGroupa.add(item));
        return item;
    }
}
